<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
	xmlns:gslib="http://www.greenstone.org/skinning"
	extension-element-prefixes="java util"
	exclude-result-prefixes="java util xsl gslib">



	<!-- the page content -->
	<xsl:template match="/page/pageResponse">

		<div id="quickSearch">
			<gslib:crossCollectionQuickSearchForm/>
		</div>

		<h2><gslib:selectACollectionTextBar/></h2>
		<xsl:call-template name="collectionAndGroupLinks"/>

		<xsl:call-template name="homePageDescription"/>

		<!--
	        <div style="clear: both; padding-top: 4px; padding-bottom: 4px;"><hr/></div>
		<xsl:variable name="siteDesc"><xsl:choose><xsl:when test="$groupPath != ''"><gslib:groupDescription path="{$groupPath}"/></xsl:when><xsl:otherwise><gslib:siteDescription/></xsl:otherwise></xsl:choose></xsl:variable>
		<xsl:if test="$siteDesc != ''">
		  <xsl:value-of select="$siteDesc"/>
		  <div style="clear: both; padding-top: 4px; padding-bottom: 4px;"><hr/></div>
		</xsl:if>
		-->
		
		<gslib:serviceClusterList/>

		<xsl:for-each select="serviceList/service[@type='query']">
			<gslib:serviceLink/><br/>
		</xsl:for-each>
		
		<xsl:for-each select="serviceList/service[@type='authen']">
			<!--<gslib:libraryInterfaceLink/><br/><br/>-->
			<gslib:authenticationLink/><br/><br/>
			<gslib:depositorTitleMainLink/><br/><br/>
			<gslib:registerLink/><br/><br/>
		</xsl:for-each>

		<!--
		<gslib:oaipmhServerLink/><br/><br/>
		-->

		<gslib:webswingGLILink/><br/><br/>		
		
		<gslib:aboutGreenstoneLink/><br/>
	</xsl:template>

	<xsl:template name="homePageDescriptionXXXXX">
	        <div style="clear: both; padding-top: 4px; padding-bottom: 4px;"><hr/></div>
		<xsl:variable name="siteDesc"><xsl:choose><xsl:when test="$groupPath != ''"><gslib:groupDescription path="{$groupPath}"/></xsl:when><xsl:otherwise><gslib:siteDescription/></xsl:otherwise></xsl:choose></xsl:variable>
		<xsl:if test="$siteDesc != ''">
		  <xsl:value-of select="$siteDesc"/>
		  <div style="clear: both; padding-top: 4px; padding-bottom: 4px;"><hr/></div>
		</xsl:if>
	</xsl:template>
	

  <xsl:template name="homePageDescription">
    <div style="clear: both; padding-top: 4px; padding-bottom: 4px;"><hr/></div>
    <div style="float: right; width: 300px;">
      <img style="width: 100%;" src="interfaces/{$interface_name}/images/intermuse-title-logo.png" />
      <div style="float: right; padding-right: 0.7em;">
	<a href="/fuseki3/dataset.html?tab=query&amp;ds=/greenstone">Access as Linked Data</a>
      </div>
    </div>
    
    <p style="padding-top: 0.7rem;">
      
      Live musical events play a vital role in community life across the
      globe, yet their very ‘liveness’ means they often leave only faint
      traces on the historical record, even in modern times. While
      musicologists have used some types of concert ephemera to capture the
      nature and identity of musical events, by their very nature these
      resources can be confusingly inconsistent, tantalisingly incomplete,
      and often scattered between different archives and collections.
    </p>
    <!--
      <p>
			      This <i>prototype</i> InterMusE Digital Library is a resource developed as the result
			      of a two-year project, funded by AHRC’s UK-US New Directions for Digital
			      Scholarship in Cultural Institutions programme, that seeks
			      to better capture and represent these historical events.

			      Using natural-language processing, optical character recognition (OCR),
			      and other forms of artificial intelligence, this digital library 
			      brings together an array of digitised resources sourced from:
      </p>
  -->
			    
    <p>
      This <a href="https://intermuse.datatodata.org/" target="_blank">InterMusE Project</a>
      is a two-year research endeavour,
      funded by AHRC’s UK-US New Directions for Digital
      Scholarship in Cultural Institutions programme, that seeks
      to better capture and represent these historical events,			      
      leveraging natural-language processing, optical character recognition (OCR),
      and other forms of artificial intelligence.
      To illustrate the potential of the approach we work with digitised resources
      sourced from:
    </p>
    
    <ul>
      <li>
	<a href="https://www.york.ac.uk/borthwick/" target="_blank" rel="noreferrer noopener">Borthwick Institute for Archives</a> (University of York),
      </li>
      <li>
	<a href="https://krannertcenter.com/" target="_blank" rel="noreferrer noopener">Krannert Center for the Performing Arts</a> (University of Illinois at Urbana-Champaign),
      </li>
      <!--
      <li>
	<a href="https://linenhall.com/?gclid=CjwKCAiAmrOBBhA0EiwArn3mfAtN1-wdaaatezqK2X672WkKTS2he3g-8eDTZPc2INaYSHIdBQ4DExoCh-kQAvD_BwE" target="_blank" rel="noreferrer noopener">Linen Hall Library (Belfast)</a>, and
      </li>
      -->
      <li>
	<a href="https://www.bl.uk/" target="_blank" rel="noreferrer noopener">The British Library,</a> and
      </li>
      <li>
	<a href="https://www.rcm.ac.uk/" target="_blank" rel="noreferrer noopener">The Royal College of Music.</a>
      </li>
    </ul>
    <p>Material is also sourced from three former chapters of the British Music Society (est. 1918):</p>
    <ul>
      <li>
	<a href="http://www.huddersfield-music-society.org.uk/" target="_blank" rel="noreferrer noopener">Huddersfield Music Society,</a>
      </li>
      <li>
	<a href="http://www.bms-york.org.uk/" target="_blank" rel="noreferrer noopener">British Music Society of York,</a> and
      </li>
      <li>
	<a href="https://www.belfastmusicsociety.org/" target="_blank" rel="noreferrer noopener">Belfast Music Society.</a>
      </li>
    </ul>
    
    
    
    <h3>Prototype Digital Library</h3>
    
    <p>
      Greenstone3 is an open-source digital-library system with a
      versatile service-based software architecture, managed through
      an extension mechanism.  Taking the Huddersfield Music Society
      Programmes as the set of digitised content processed, this
      online resource demonstrates how Greenstone3 can be used to meet
      the aspirations of the InterMusE project.
    </p>
    
    <!--
	<p>
	This prototype collection contains <xsl:value-of select="$numdocs"/> documents
	focusing on a sample of programmes from the Huddersfield Music Society.
	</p>
    -->
    
    <p>
      <!-- Linked Open Data is used to unify these resources. -->
      
      When content is added to the digital library, it is automatically
      processed using the Google Vision API, and any text extracted is added
      to the digital library's full-text index,
      as well as stored as Linked Open Data using the
      <a href="https://dev.gdmrdigital.com/" target="_blank">SimpleAnnotationServer</a>.
      We make the OCR'd text available as Open Annotations,
      accessible through a <a href="https://projectmirador.org/" target="_blank">Mirador3 Image Viewer</a>
      embedded into the digital library.
      Through the Mirador3 Viewer, annotations can be edited (correcting OCR errors, for example),
      as well as allowing for the
      addition of complete new annotations (unrelated to the OCR'd text, if so desired).
      Because <a href="https://jena.apache.org/" target="_blank">Apache Jena Fuseki</a>
      is the internal triplestore the Simple Annotation Server uses,
      this means all the OCR'd content—along with
      all the other metadata amassed in the digital library—can also be accessed via a SPARQL endpoint.
      More details are available through the
      <a href="https://intermuse.datatodata.org/" target="_blank">InterMuse project website</a>.
    </p>

        <!--
    <p>
      Prior to the start of the InterMusE project, HMS archivist
      Hilary Norcliffe had been painstakingly assembled from the
      programmes an Excel spreadsheet which records who the performers
      were, and which musical works they performed at what concert.
      In addition to the automatically generated OCR'd content, we
      fold this into the digital library collection, both as
      information to display, but also as metadata that can be used to
      enrich how users can locate content of interest to them in the
      collection.
    </p>
	-->
	

    <p>
      In addition to the automatically generated OCR'd content,
      an Excel spreadsheet has been painstakingly
      assembled from the programmes 'by the HMS archivist'
      recording who the performers were, and which musical works they
      performed at what concert.
      We fold this into the digital-library collection, both as
      information to display, but also as metadata that can be used to
      enrich how users can locate content of interest to them in the
      collection.
      
      
    <h3>Designed for Different Types of User</h3>
    <p>
      Use the browsing and searching features the digital library provides to locate content
      of interest.  Register as a user to become an annotator/editor of the content.
      For an external developer, interested in further enriching the forms of access to this content,
      a machine-readable version of the content is accessible through the following
      <a href="{$library_name}/collection/{$collName}/page/sparql">SPARQL endpoint</a>.
    </p>
    <p>
      <gslib:collectionDescriptionTextAndServicesLinks/>
    </p>
    
    <xsl:variable name="raw_date">
      <gslib:collectionMeta name="buildDate"/>
    </xsl:variable>
    <xsl:variable name="formatted_date">
      <xsl:value-of select="util:formatTimeStamp($raw_date, 0, 3, /page/@lang)"/>
    </xsl:variable>
    <xsl:variable name="numdocs">
      <gslib:collectionMeta name="numDocs"/>
    </xsl:variable>
    <p>
      This prototype collection contains <xsl:value-of select="$numdocs"/> documents focusing on a sample of programmes from the Huddersfield Music Society.
      <!--
	  <xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'about.standarddescriptiondays', concat($numdocs, ';', $formatted_date))"/>
      -->
    </p>
    
    
    <h3>Implementation Details</h3>
    
    <p>
      To form this prototype InterMusE digital library, we have taken
      the base digital-library system and added in Greenstone's
      extensions for:
      <ul>
	<li>
	  <a href="https://trac.greenstone.org/browser/gs3-extensions/structured-image/trunk">structured-image</a>
	  to automatically perform OCR on programme pages using Google Vision's API;
	</li>
	<li>
	  <a href="https://trac.greenstone.org/browser/gs3-extensions/iiif-servlet/trunk/src">iiif-servlet</a>
	  to allow images in the digital library to be
	  available at a range of resolutions via the IIIF Image API; and
	</li>
	<li>
	  <a href="https://trac.greenstone.org/browser/gs2-extensions/apache-jena/trunk/src">apache-jena</a>
	  so that content—such as annotations added to
	  programme pages—can be accessed as Linked Data.
	</li>
      </ul>
    </p>
    
    <p>
      A key strength of the Greenstone3 software architecture is its
      ability to be customised, which is aligned with its three phases
      for forming a digital-library collection: importing, building,
      and runtime presentation.  The first two phases typically go
      hand-in-hand, and form the ingest process by which content
      selected for the digital-library collection is turned into a
      browseable and searchable online resource.
    </p>
    <p>
      Importing centres around a pipeline of document-processing
      plugins, written in Perl, that turn a wide array of document
      and metadata formats into a canonical format known as
      GreenstoneXML.  Using one folder per document, this format
      represents everything that constitutes the processed document:
      the text and metadata of the document,
      along with any supporting files.  The internal format
      allows for hierarchical structure, such as which occurs
      in Word, PDF, and HTML documents using headings.
      Metadata can be attached to any level of the hierarchy.
      Examples of associated files include: automatically generated
      web-friendly resources, such as
      <!-- as an MP3 version of
	   a high quailty FLAC audio recording, for instance, -->
      screen-sized and thumbnail-sized images in the case
      of photos; embedded resources in the case of HTML;  and the original file itself, so it can be
      downloaded. 
      
      <!-- GreenstoneMETS -->
    </p>
    <p>
      In terms of customisation, plugins support a
      myriad of settings for fine-tuning how the processing is
      undertaken.  New plugins can also be introduced at any time,
      with the digital-library system automatically detecting their
      presence.
    </p>
    
    <p>
      The building step takes the standardised XML form, and processes
      it to form the backend indexes and database structures needed to
      deliver the forms of searching—such as full-text search, and
      search by title—and browsing—such as a hierarchical subject
      classification—specified in the collection's configuration file.
      
      Effectively the building phase turns the standardised/serialised
      GreenstoneXML form back into in-memory data-structures representing
      a document's hierarchical structure of text and metadata, along
      with how supporting files relate to that.
      Following the directives specified in the collection's
      configuration file, it is
      then a simple matter to transmit this text, metadata, and associated
      files as needed to the digital-library's indexing/database/backing-store.
      <!--
	  so it can be used by the runtime system to provide the
	  
	  to be used by the runtime system
      -->
    </p>
    <p>	    
      Beyond the customisations that can be specified in a
      collection-configuration file for the building phase, Greenstone
      supports orthogonal indexers.  Like the document-processing
      plugins used in importing, orthogonal indexers are modules
      written in Perl, and their inclusion is automatically detected
      by the Greenstone3 installation.  Orthogonal indexers get
      presented with the same in-memory stream of
      &quot;reconstructed&quot; documents, allowing them to undertake
      additional processing if required (such as computing audio
      features), which can then be transmitted to a specialist
      indexing/database/backing-store (such as a content-based
      music-recommender system), or otherwise added to the existing
      indexing/database/backing-store.
    </p>
    <p>
      The third phase of the Greenstone3 digital-library architecture
      governs how functionality is accessed and data is extracted from
      the digital library and presented to the user. The Greenstone3
      runtime is a service-based architecture, written in Java,
      consisting of a network of connected modules.  Modules are
      self-describing and advertise the services they offer.
      Communication between modules is by XML messages, with the
      service handling the final layer of communication responsible
      for presentation.  Here, XSL Transforms (XSLTs) are used to
      convert the underlying XML content into the web page displayed
      by the digital library, blending in CSS and Javascript
      files that control appearance and functionality.

    </p>
    <p>
      The XSLT files are grouped together in one place, forming the
      interface for the digital library. An inheritance mechanism is
      deployed throughout this part of the design.  A collection can
      override individual XSLT template rules, as required to tweak
      presentation details.  A collection can also provide an entire
      replacement XSLT file, if so desired.  For more substantial
      changes a new interface is typically developed.
    </p>

    <p>
      
      In terms of crafting the features and functionality to form this
      prototype InterMusE digital library, we make use of all three
      areas for customisation.  Mirador3 is a NodeJS web stack, and so
      to switch the digital library's document display to use this
      viewer, replacement XSL template rules were introduced to load
      in the necessary CSS and JavaScript files, and call the viewer's
      initialisation function.  Mirador draws its image content from
      an IIIF compliant server.  This was achieved by using the above
      mentioned IIIF-Servlet extension to Greenstone3.  Mirador,
      however, cannot natively handle Google Vision JSON, but does
      support the OpenAnnotation JSON format.  We therefore extended
      <i>StructuredImagePlugin</i> to include a function that performs
      a cross-walk of the former JSON format to the latter.
    </p>

    <p>
      To support the editing of annotations the
      sequence undertaken is informally, but best, described as ``a
      plumbing exercise.''  Mirador3 requires the addition of the
      <i>mirador-annotations</i> plugin to allow editing.  This in
      turn was configured to direct the plugin to use a Simple
      Annotation Server (SAS) endpoint to store the annotations.  SAS
      supports a variety of different storage backends.  We set this
      to be Apache Jena and directed SAS to use the one we had
      installed as a Greenstone3 extension.  To get the
      OpenAnnotations produced by <i> StructuredImagePlugin</i> into
      the Jena store, we added in a new orthogonal indexer.  The net
      result of all of this is that, upon a fresh rebuild of the digital-library
      collection, a user accessing one of the digitised programmes can
      now edit the OCR'd text, or else lay in new annotations over the
      page.  An XSLT-based <i>if-statement</i> completes the plumbing
      exercise, checking settings provided by the digital library to ensure the
      editing-based version of the Mirador viewer is only activated if
      the user is logged in and has an editing role assigned for the
      collection they are accessing.
    </p>

      
<!--
      there
      are three keys parts of the Greenstone3 design where 
      
      area where customisation
      

      digital library collection into 
      
			      the online resource

			      features and functionality
			      
			      In developing a Greenstone3 digital library collection, there are three key phases
			      to consider: importing, building, and runtime-display.

			      The first
			      XML message based .. XSL Transforms (XSLT)
			      
			      The there are three key phases to the 

			      Its modular design
			      
			      The modular design of Greenstone3 provides several stages where 
			      
			      ...

			      importing
			      building
			      runtime-display
			      
			      orthogonal indexes
-->

<!--
    Three key 'hook-in' points within the Greenstone3 software architecture
    for customisation are: the Perl-based document-processing plugins
    used in the content ingest pipeline, through which
    content and metadata are ingested into a digital library
    collection
    
    Perl-based document-processing pipeline
    
    Woven together in the following way
    
    We have applied
    
    Mirador
    SimpleAnnotationServer
    
    This forms the framework for this developed
    
    In developing this online resource, we have applied it 
			      -->
    </p>
    
    <h2>Available Services</h2>
    
  </xsl:template>
</xsl:stylesheet>
